<?php
/*  OV::
	запрет на просмотр имеет преимущество перед разрешением
	в случае конфликтов между ними
*/
class onRvupUsersProfileView extends cmsAction {

    public function run($profile){

        $user = cmsUser::getInstance();
		$user_id = $user->id;
		$user_groups = $user->groups;
		$profile_id = $profile['id'];
		$profile_groups = $profile['groups'];
		
		if(empty($this->options['groups_hidden']) || empty($this->options['groups_forbinden'])) {
			return $profile;
		}
		$groups_hidden = !empty($this->options['groups_hidden']) ? $this->options['groups_hidden'] : array();
		$groups_forbinden = !empty($this->options['groups_forbinden']) ? $this->options['groups_forbinden'] : array();

		$is_hidden_profile = !empty($groups_hidden) ? array_uintersect($groups_hidden, $profile_groups, 'strcasecmp') : false;
		$is_forbinden_user = !empty($groups_forbinden) ? array_uintersect($groups_forbinden, $user_groups, 'strcasecmp') : false;
		if(!empty($this->options['same_group'] && $user_groups == $profile_groups)) {
			$is_forbinden_user = false;
		}

		$allowed_view = $user->is_logged && $is_forbinden_user == false || $user_id == $profile_id || $user->is_admin || !$groups_hidden || !$is_hidden_profile;

		if($allowed_view) {

			return $profile;

		} else {
			
			if($this->options['page_options'] == 'error') {
				
				$error_hint = !empty($this->options['error_message']) ? $this->options['error_message'] : '';
				cmsCore::errorForbidden($message = $error_hint, $show_login_link = false);
				
				return $profile;
			
			} else {

				$popup_message = !empty($this->options['popup_message']) ? $this->options['popup_message'] : false;
				if($popup_message) {
					$this->cms_template->render('profile_closed_rvup', array(
						'message'         => $popup_message
					));
				}

				if(!empty($this->options['allow_messages'])) {
					$this->cms_template->menus['toolbar'] = null;
				}

				if(!empty($this->options['hide_avatar'])) {
					$profile['avatar'] = '';
				}
				$profile['privacy_options'] = array (
					'view_user_comments' => '',
					'view_user_pages' => '',
					'view_user_articles' => '',
					'view_user_posts' => '',
					'view_user_albums' => '',
					'view_user_board' => '',
					'view_user_news' => '',
					'view_user_groups' => '',
					'invite_group_users' => '',
					'messages_pm' => '',
					'users_profile_view' => '',
					'users_friendship' => '',
					'users_profile_wall' => '',
					'users_profile_wall_reply' => ''
				);

				return $profile;

			}

		}

		return $profile;

    }
}
